<?php
error_reporting(0);

/* Konfiguration: Datei "config.inc.php" mit folgendem Inhalt anlegen: --------------------------

<?php
// GREYHOUND Zugangsdaten:
$config['host'] = '192.168.x.y';
$config['port'] = 443;
$config['ssl'] = true;
$config['username'] = 'Benutzername';
$config['password'] = 'Kennwort';
$config['timeout'] = 60;

// Entweder die ID oder der Name des Im-/Exports muss hier angegeben werden:
$config['dataexchange_id'] = 0; // ID des GREYHOUND Im-/Exports
//$config['dataexchange_name'] = 'CSV-Import'; // Name des GREYHOUND Im-/Exports

// CSV-Datei:
$config['csv_file'] = $baseDir . 'import.csv'; // Datei "contacts.csv" im selben Ordner wie das Skript

------------------------------------------------------------------------------------------------- */

$baseDir = dirname(__FILE__) . '/';
$config = array();

if(file_exists($baseDir . 'config.inc.php'))
  include $baseDir . 'config.inc.php';

if(!$config['csv_file'])
  die('Keine CSV-Datei angegeben.');

if(!file_exists($config['csv_file']))
  die('CSV-Datei wurde nicht gefunden.');

require_once $baseDir . 'lib/ghrpc/ghrpc.php';

$client = new GhRpcClient($config['host'], $config['port'], $config['ssl'], $config['username'], $config['password']);
$service = rpc_dataexchangelib::newRpcDataExchanges($client);

$dataExchange = null; /* @var GhRpcDataexchangelibRpcDataExchange $dataExchange */

foreach($service->GetList() as $tmpDataExchange) {
  /* @var GhRpcDataexchangelibRpcDataExchange $tmpDataExchange */
  if( (isset($config['dataexchange_id']) && $config['dataexchange_id'] && $tmpDataExchange->ID == $config['dataexchange_id']) ||
      (isset($config['dataexchange_name']) && $config['dataexchange_name'] && $tmpDataExchange->Name == $config['dataexchange_name']) ) {
    $dataExchange = $tmpDataExchange;
    break;
  }
}

if($dataExchange) {
  $service->Lock($dataExchange->ID);

  try {
    $csv = file_get_contents($config['csv_file']);
    $client->uploadDataExchange($dataExchange->ID, $csv, basename($config['csv_file']));
    echo 'CSV Datei erfolgreich hochgeladen.';
  }
  catch(Exception $e) {
    echo 'Fehler: ' . $e->getMessage();
  }
  finally {
    $service->Unlock($dataExchange->ID);
  }
}
