<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2017 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_extensionslib.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Units
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_extensionslib extends GhRpcLibrary
{
  // RpcExtensionFormOption Konstanten:

  /**
   * efoToolbar Konstante (gehört zum Enum: RpcExtensionFormOption).
   */
  const efoToolbar = 0;
  /**
   * efoStatusbar Konstante (gehört zum Enum: RpcExtensionFormOption).
   */
  const efoStatusbar = 1;

  // RpcExtensionFormKind Konstanten:

  /**
   * efkDialog Konstante (gehört zum Enum: RpcExtensionFormKind).
   */
  const efkDialog = 0;
  /**
   * efkResizeable Konstante (gehört zum Enum: RpcExtensionFormKind).
   */
  const efkResizeable = 1;

  // RpcExtensionVariablePostVar Konstanten:

  /**
   * evpvYes Konstante (gehört zum Enum: RpcExtensionVariablePostVar).
   */
  const evpvYes = 0;
  /**
   * evpvNo Konstante (gehört zum Enum: RpcExtensionVariablePostVar).
   */
  const evpvNo = 1;

  // RpcExtensionState Konstanten:

  /**
   * esInactive Konstante (gehört zum Enum: RpcExtensionState).
   */
  const esInactive = 0;
  /**
   * esActive Konstante (gehört zum Enum: RpcExtensionState).
   */
  const esActive = 1;

  // RpcExtensionOption Konstanten:

  /**
   * eoExtensionsMenu Konstante (gehört zum Enum: RpcExtensionOption).
   */
  const eoExtensionsMenu = 0;
  /**
   * eoContextMenu Konstante (gehört zum Enum: RpcExtensionOption).
   */
  const eoContextMenu = 1;
  /**
   * eoAutoCall Konstante (gehört zum Enum: RpcExtensionOption).
   */
  const eoAutoCall = 2;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsForbidden Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForbidden = 1;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 2;
  /**
   * wsForeign Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForeign = 3;

  // RpcExtensionVariableKind Konstanten:

  /**
   * evkWholeText Konstante (gehört zum Enum: RpcExtensionVariableKind).
   */
  const evkWholeText = 0;
  /**
   * evkSelectedText Konstante (gehört zum Enum: RpcExtensionVariableKind).
   */
  const evkSelectedText = 1;
  /**
   * evkSystemVar Konstante (gehört zum Enum: RpcExtensionVariableKind).
   */
  const evkSystemVar = 2;
  /**
   * evkValue Konstante (gehört zum Enum: RpcExtensionVariableKind).
   */
  const evkValue = 3;

  // RpcExtensionKind Konstanten:

  /**
   * ekBrowser Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekBrowser = 0;
  /**
   * ekApplication Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekApplication = 1;
  /**
   * ekMessage Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekMessage = 2;
  /**
   * ekForm Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekForm = 3;
  /**
   * ekModuleTab Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekModuleTab = 4;
  /**
   * ekAccessTab Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekAccessTab = 5;
  /**
   * ekPreviewTab Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekPreviewTab = 6;
  /**
   * ekPreviewHeader Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekPreviewHeader = 7;
  /**
   * ekBackgroundUrl Konstante (gehört zum Enum: RpcExtensionKind).
   */
  const ekBackgroundUrl = 8;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcExtensions.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcExtensionslibRpcExtensions
   */
  public static function newRpcExtensions(GhRpcClient $client)
  {
    return new GhRpcExtensionslibRpcExtensions($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcExtensionDataVariable.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcExtensionslibRpcExtensionDataVariable
   */
  public static function newRpcExtensionDataVariable($fillProperties = false)
  {
    $object = new GhRpcExtensionslibRpcExtensionDataVariable();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcExtensionItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcExtensionslibRpcExtensionItem
   */
  public static function newRpcExtensionItem($fillProperties = false)
  {
    $object = new GhRpcExtensionslibRpcExtensionItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcExtensionVariable.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcExtensionslibRpcExtensionVariable
   */
  public static function newRpcExtensionVariable($fillProperties = false)
  {
    $object = new GhRpcExtensionslibRpcExtensionVariable();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcExtensionslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcExtensionslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcExtension.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcExtensionslibRpcExtension
   */
  public static function newRpcExtension($fillProperties = false)
  {
    $object = new GhRpcExtensionslibRpcExtension();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcExtensionDataVariableList.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcExtension extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * CategoryRefs
   * @var array
   */
  public $CategoryRefs;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * FormKind
   * @var int
   */
  public $FormKind;

  /**
   * FormOptions
   * @var int
   */
  public $FormOptions;

  /**
   * Options
   * @var int
   */
  public $Options;

  /**
   * Width
   * @var int
   */
  public $Width;

  /**
   * Height
   * @var int
   */
  public $Height;

  /**
   * Identifier
   * @var string
   */
  public $Identifier;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Command
   * @var string
   */
  public $Command;

  /**
   * Parameter
   * @var string
   */
  public $Parameter;

  /**
   * Data
   * @var string
   */
  public $Data;

  /**
   * MessageId
   * @var int
   */
  public $MessageId;

  /**
   * Icon
   * @var string
   */
  public $Icon;

  /**
   * ModuleClasses
   * @var string
   */
  public $ModuleClasses;

  /**
   * Variables
   * @var array
   */
  public $Variables;

  /**
   * LockData
   * @var GhRpcExtensionslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'CategoryRefs' => 'array:int',
    'WorkSpace' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'FormKind' => 'int',
    'FormOptions' => 'int',
    'Options' => 'int',
    'Width' => 'int',
    'Height' => 'int',
    'Identifier' => 'string',
    'Name' => 'string',
    'Command' => 'string',
    'Parameter' => 'string',
    'Data' => 'string',
    'MessageId' => 'int',
    'Icon' => 'binary',
    'ModuleClasses' => 'string',
    'Variables' => 'array:GhRpcExtensionslibRpcExtensionVariable',
    'LockData' => 'GhRpcExtensionslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcExtensionDataVariableList.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcExtensionDataVariableList.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcExtensionVariable extends GhRpcStruct
{
  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * RegEx
   * @var string
   */
  public $RegEx;

  /**
   * Match
   * @var string
   */
  public $Match;

  /**
   * PostVar
   * @var int
   */
  public $PostVar;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Kind' => 'int',
    'Name' => 'string',
    'Value' => 'string',
    'RegEx' => 'string',
    'Match' => 'string',
    'PostVar' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcExtensionDataVariableList.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcExtensionItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * FormKind
   * @var int
   */
  public $FormKind;

  /**
   * FormOptions
   * @var int
   */
  public $FormOptions;

  /**
   * Options
   * @var int
   */
  public $Options;

  /**
   * Width
   * @var int
   */
  public $Width;

  /**
   * Height
   * @var int
   */
  public $Height;

  /**
   * Identifier
   * @var string
   */
  public $Identifier;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Icon
   * @var string
   */
  public $Icon;

  /**
   * ModuleClasses
   * @var string
   */
  public $ModuleClasses;

  /**
   * LockData
   * @var GhRpcExtensionslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'WorkSpace' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'FormKind' => 'int',
    'FormOptions' => 'int',
    'Options' => 'int',
    'Width' => 'int',
    'Height' => 'int',
    'Identifier' => 'string',
    'Name' => 'string',
    'Icon' => 'binary',
    'ModuleClasses' => 'string',
    'LockData' => 'GhRpcExtensionslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcExtensionDataVariableList.
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcExtensionDataVariable extends GhRpcStruct
{
  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Name' => 'string',
    'Value' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcExtensions
 *
 * @package GhRpc
 * @subpackage rpc_extensionslib
 * @category PHP-RPC-Dienste
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcExtensionslibRpcExtensions extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcExtensionslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'PutSettings' => array(
      'params' => array(
        'ProductID' => 'string',
        'Settings' => 'string',
      ),
      'return' => '',
    ),
    'GetSettings' => array(
      'params' => array(
        'ProductID' => 'string',
      ),
      'return' => 'string',
    ),
    'Export' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'string',
    ),
    'Import' => array(
      'params' => array(
        'XmlData' => 'string',
      ),
      'return' => 'int',
    ),
    'AddCategory' => array(
      'params' => array(
        'ID' => 'int',
        'CategoryRef' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Extension' => 'GhRpcExtensionslibRpcExtension',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Extension' => 'GhRpcExtensionslibRpcExtension',
      ),
      'return' => 'int',
    ),
    'GetData' => array(
      'params' => array(
        'ID' => 'int',
        'ItemRef' => 'int',
        'DataVariables' => 'array:GhRpcExtensionslibRpcExtensionDataVariable',
      ),
      'return' => 'GhRpcExtensionslibRpcExtension',
    ),
    'GetCompleteList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcExtensionslibRpcExtensionItem',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcExtensionslibRpcExtensionItem',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcExtensionslibRpcExtension',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcExtensions.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcExtensionslibRpcExtension
   */
  public function Get($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcExtensions.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.GetCompleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetCompleteList()
  {
    return $this->_sendRpcRequest('RpcExtensions.GetCompleteList', array(), self::$_rpcMethods['GetCompleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.GetData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ItemRef
   * @param array $DataVariables
   *
   * @return GhRpcExtensionslibRpcExtension
   */
  public function GetData($ID, $ItemRef, array $DataVariables)
  {
    return $this->_sendRpcRequest('RpcExtensions.GetData', array($ID, $ItemRef, $DataVariables), self::$_rpcMethods['GetData']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcExtensionslibRpcExtension $Extension
   *
   * @return int
   */
  public function New_(GhRpcExtensionslibRpcExtension $Extension)
  {
    return $this->_sendRpcRequest('RpcExtensions.New', array($Extension), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcExtensionslibRpcExtension $Extension
   */
  public function Put(GhRpcExtensionslibRpcExtension $Extension)
  {
    return $this->_sendRpcRequest('RpcExtensions.Put', array($Extension), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.AddCategory auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $CategoryRef
   */
  public function AddCategory($ID, $CategoryRef)
  {
    return $this->_sendRpcRequest('RpcExtensions.AddCategory', array($ID, $CategoryRef), self::$_rpcMethods['AddCategory']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Import auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $XmlData
   *
   * @return int
   */
  public function Import($XmlData)
  {
    return $this->_sendRpcRequest('RpcExtensions.Import', array($XmlData), self::$_rpcMethods['Import']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Export auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return string
   */
  public function Export($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.Export', array($ID), self::$_rpcMethods['Export']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.GetSettings auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $ProductID
   *
   * @return string
   */
  public function GetSettings($ProductID)
  {
    return $this->_sendRpcRequest('RpcExtensions.GetSettings', array($ProductID), self::$_rpcMethods['GetSettings']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.PutSettings auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $ProductID
   * @param string $Settings
   */
  public function PutSettings($ProductID, $Settings)
  {
    return $this->_sendRpcRequest('RpcExtensions.PutSettings', array($ProductID, $Settings), self::$_rpcMethods['PutSettings']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcExtensions.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcExtensionslibRpcLockData
   */
  public function GetLockData($ID)
  {
    return $this->_sendRpcRequest('RpcExtensions.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
