<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2017 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_filterslib.
 *
 * @package GhRpc
 * @subpackage rpc_filterslib
 * @category PHP-RPC-Units
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_filterslib extends GhRpcLibrary
{
  // RpcCombineOperator Konstanten:

  /**
   * cmAnd Konstante (gehört zum Enum: RpcCombineOperator).
   */
  const cmAnd = 0;
  /**
   * cmOr Konstante (gehört zum Enum: RpcCombineOperator).
   */
  const cmOr = 1;

  // RpcCompareOperator Konstanten:

  /**
   * coEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coEqual = 0;
  /**
   * coNotEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotEqual = 1;
  /**
   * coStarts Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coStarts = 2;
  /**
   * coNotStarts Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotStarts = 3;
  /**
   * coEnds Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coEnds = 4;
  /**
   * coNotEnds Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotEnds = 5;
  /**
   * coContains Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coContains = 6;
  /**
   * coNotContains Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotContains = 7;
  /**
   * coGreater Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coGreater = 8;
  /**
   * coGreaterEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coGreaterEqual = 9;
  /**
   * coLess Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coLess = 10;
  /**
   * coLessEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coLessEqual = 11;

  // RpcUserFieldDataType Konstanten:

  /**
   * ufdtString Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtString = 0;
  /**
   * ufdtInteger Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInteger = 1;
  /**
   * ufdtInt64 Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInt64 = 2;
  /**
   * ufdtBoolean Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBoolean = 3;
  /**
   * ufdtDateTime Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtDateTime = 4;
  /**
   * ufdtFloat Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtFloat = 5;
  /**
   * ufdtBlob Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBlob = 6;

  // RpcDateField Konstanten:

  /**
   * dfStartDate Konstante (gehört zum Enum: RpcDateField).
   */
  const dfStartDate = 0;
  /**
   * dfEndDate Konstante (gehört zum Enum: RpcDateField).
   */
  const dfEndDate = 1;
  /**
   * dfCreated Konstante (gehört zum Enum: RpcDateField).
   */
  const dfCreated = 2;
  /**
   * dfModified Konstante (gehört zum Enum: RpcDateField).
   */
  const dfModified = 3;

  // RpcOperator Konstanten:

  /**
   * oLessEqual Konstante (gehört zum Enum: RpcOperator).
   */
  const oLessEqual = 0;
  /**
   * oLess Konstante (gehört zum Enum: RpcOperator).
   */
  const oLess = 1;
  /**
   * oEqual Konstante (gehört zum Enum: RpcOperator).
   */
  const oEqual = 2;
  /**
   * oGreater Konstante (gehört zum Enum: RpcOperator).
   */
  const oGreater = 3;
  /**
   * oGreaterEqual Konstante (gehört zum Enum: RpcOperator).
   */
  const oGreaterEqual = 4;

  // RpcLoadReferences Konstanten:

  /**
   * lrNo Konstante (gehört zum Enum: RpcLoadReferences).
   */
  const lrNo = 0;
  /**
   * lrDifferent Konstante (gehört zum Enum: RpcLoadReferences).
   */
  const lrDifferent = 1;
  /**
   * lrAlways Konstante (gehört zum Enum: RpcLoadReferences).
   */
  const lrAlways = 2;

  // RpcOption Konstanten:

  /**
   * oCountTotal Konstante (gehört zum Enum: RpcOption).
   */
  const oCountTotal = 0;
  /**
   * oCountRead Konstante (gehört zum Enum: RpcOption).
   */
  const oCountRead = 1;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  // RpcFlag Konstanten:

  /**
   * fRead Konstante (gehört zum Enum: RpcFlag).
   */
  const fRead = 0;
  /**
   * fDeleted Konstante (gehört zum Enum: RpcFlag).
   */
  const fDeleted = 1;
  /**
   * fEscalated Konstante (gehört zum Enum: RpcFlag).
   */
  const fEscalated = 2;
  /**
   * fSpam Konstante (gehört zum Enum: RpcFlag).
   */
  const fSpam = 3;
  /**
   * fFailure Konstante (gehört zum Enum: RpcFlag).
   */
  const fFailure = 4;
  /**
   * fWaiting Konstante (gehört zum Enum: RpcFlag).
   */
  const fWaiting = 5;
  /**
   * fUnsent Konstante (gehört zum Enum: RpcFlag).
   */
  const fUnsent = 6;
  /**
   * fAttachment Konstante (gehört zum Enum: RpcFlag).
   */
  const fAttachment = 7;
  /**
   * fWholeday Konstante (gehört zum Enum: RpcFlag).
   */
  const fWholeday = 8;
  /**
   * fRecurrence Konstante (gehört zum Enum: RpcFlag).
   */
  const fRecurrence = 9;
  /**
   * fUnclassifiable Konstante (gehört zum Enum: RpcFlag).
   */
  const fUnclassifiable = 10;
  /**
   * fProtocol Konstante (gehört zum Enum: RpcFlag).
   */
  const fProtocol = 11;
  /**
   * fRemarks Konstante (gehört zum Enum: RpcFlag).
   */
  const fRemarks = 12;
  /**
   * fUseHtml Konstante (gehört zum Enum: RpcFlag).
   */
  const fUseHtml = 13;
  /**
   * fEml Konstante (gehört zum Enum: RpcFlag).
   */
  const fEml = 14;
  /**
   * fDeliveryNotification Konstante (gehört zum Enum: RpcFlag).
   */
  const fDeliveryNotification = 15;
  /**
   * fCampaign Konstante (gehört zum Enum: RpcFlag).
   */
  const fCampaign = 16;

  // RpcPriority Konstanten:

  /**
   * pLowest Konstante (gehört zum Enum: RpcPriority).
   */
  const pLowest = 0;
  /**
   * pLow Konstante (gehört zum Enum: RpcPriority).
   */
  const pLow = 1;
  /**
   * pNormal Konstante (gehört zum Enum: RpcPriority).
   */
  const pNormal = 2;
  /**
   * pHigh Konstante (gehört zum Enum: RpcPriority).
   */
  const pHigh = 3;
  /**
   * pHighest Konstante (gehört zum Enum: RpcPriority).
   */
  const pHighest = 4;

  // RpcKind Konstanten:

  /**
   * kEmail Konstante (gehört zum Enum: RpcKind).
   */
  const kEmail = 0;
  /**
   * kFax Konstante (gehört zum Enum: RpcKind).
   */
  const kFax = 1;
  /**
   * kLetter Konstante (gehört zum Enum: RpcKind).
   */
  const kLetter = 2;
  /**
   * kShortMessage Konstante (gehört zum Enum: RpcKind).
   */
  const kShortMessage = 3;
  /**
   * kCall Konstante (gehört zum Enum: RpcKind).
   */
  const kCall = 4;
  /**
   * kAppointment Konstante (gehört zum Enum: RpcKind).
   */
  const kAppointment = 5;
  /**
   * kTask Konstante (gehört zum Enum: RpcKind).
   */
  const kTask = 6;
  /**
   * kNote Konstante (gehört zum Enum: RpcKind).
   */
  const kNote = 7;
  /**
   * kContact Konstante (gehört zum Enum: RpcKind).
   */
  const kContact = 8;
  /**
   * kFile Konstante (gehört zum Enum: RpcKind).
   */
  const kFile = 9;

  // RpcState Konstanten:

  /**
   * sOpen Konstante (gehört zum Enum: RpcState).
   */
  const sOpen = 0;
  /**
   * sNew Konstante (gehört zum Enum: RpcState).
   */
  const sNew = 1;
  /**
   * sQuestion Konstante (gehört zum Enum: RpcState).
   */
  const sQuestion = 2;
  /**
   * sAnswer Konstante (gehört zum Enum: RpcState).
   */
  const sAnswer = 3;
  /**
   * sDone Konstante (gehört zum Enum: RpcState).
   */
  const sDone = 4;
  /**
   * sForward Konstante (gehört zum Enum: RpcState).
   */
  const sForward = 5;
  /**
   * sDraft Konstante (gehört zum Enum: RpcState).
   */
  const sDraft = 6;

  // RpcSearchField Konstanten:

  /**
   * sfAddress Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfAddress = 0;
  /**
   * sfSubject Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfSubject = 1;
  /**
   * sfData Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfData = 2;
  /**
   * sfNumber Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfNumber = 3;
  /**
   * sfUserFields Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfUserFields = 4;
  /**
   * sfRemarks Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfRemarks = 5;
  /**
   * sfAttachments Konstante (gehört zum Enum: RpcSearchField).
   */
  const sfAttachments = 6;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsForbidden Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForbidden = 1;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 2;
  /**
   * wsForeign Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForeign = 3;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcFilters.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcFilterslibRpcFilters
   */
  public static function newRpcFilters(GhRpcClient $client)
  {
    return new GhRpcFilterslibRpcFilters($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserFieldItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcFilterslibRpcUserFieldItem
   */
  public static function newRpcUserFieldItem($fillProperties = false)
  {
    $object = new GhRpcFilterslibRpcUserFieldItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcFilterslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcFilterslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcFilter.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcFilterslibRpcFilter
   */
  public static function newRpcFilter($fillProperties = false)
  {
    $object = new GhRpcFilterslibRpcFilter();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_filterslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcFilterslibRpcFilter extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ParentRef
   * @var int
   */
  public $ParentRef;

  /**
   * ViewOptionRef
   * @var int
   */
  public $ViewOptionRef;

  /**
   * GroupRefs
   * @var array
   */
  public $GroupRefs;

  /**
   * UserRefs
   * @var array
   */
  public $UserRefs;

  /**
   * TopicRefs
   * @var array
   */
  public $TopicRefs;

  /**
   * ColorRefs
   * @var array
   */
  public $ColorRefs;

  /**
   * CategoryRefs
   * @var array
   */
  public $CategoryRefs;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Path
   * @var string
   */
  public $Path;

  /**
   * Icon
   * @var string
   */
  public $Icon;

  /**
   * LoadGroups
   * @var int
   */
  public $LoadGroups;

  /**
   * LoadUsers
   * @var int
   */
  public $LoadUsers;

  /**
   * LoadTopics
   * @var int
   */
  public $LoadTopics;

  /**
   * LoadColors
   * @var int
   */
  public $LoadColors;

  /**
   * Options
   * @var int
   */
  public $Options;

  /**
   * SearchFor
   * @var string
   */
  public $SearchFor;

  /**
   * SearchFields
   * @var int
   */
  public $SearchFields;

  /**
   * States
   * @var int
   */
  public $States;

  /**
   * Kinds
   * @var int
   */
  public $Kinds;

  /**
   * Priorities
   * @var int
   */
  public $Priorities;

  /**
   * PositiveFlags
   * @var int
   */
  public $PositiveFlags;

  /**
   * NegativeFlags
   * @var int
   */
  public $NegativeFlags;

  /**
   * MinClassified
   * @var int
   */
  public $MinClassified = -1;

  /**
   * MaxClassified
   * @var int
   */
  public $MaxClassified = -1;

  /**
   * StartDate
   * @var GhRpcFilterslibDatetime
   */
  public $StartDate;

  /**
   * StartOperator
   * @var int
   */
  public $StartOperator;

  /**
   * StartField
   * @var int
   */
  public $StartField;

  /**
   * EndDate
   * @var GhRpcFilterslibDatetime
   */
  public $EndDate;

  /**
   * EndOperator
   * @var int
   */
  public $EndOperator;

  /**
   * EndField
   * @var int
   */
  public $EndField;

  /**
   * MinAge
   * @var double
   */
  public $MinAge;

  /**
   * MaxAge
   * @var double
   */
  public $MaxAge;

  /**
   * MinSize
   * @var int
   */
  public $MinSize;

  /**
   * MaxSize
   * @var int
   */
  public $MaxSize;

  /**
   * MinRemind
   * @var double
   */
  public $MinRemind;

  /**
   * MaxRemind
   * @var double
   */
  public $MaxRemind;

  /**
   * UserFields
   * @var array
   */
  public $UserFields;

  /**
   * LockData
   * @var GhRpcFilterslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ParentRef' => 'int',
    'ViewOptionRef' => 'int',
    'GroupRefs' => 'array:int',
    'UserRefs' => 'array:int',
    'TopicRefs' => 'array:int',
    'ColorRefs' => 'array:int',
    'CategoryRefs' => 'array:int',
    'Order' => 'int',
    'WorkSpace' => 'int',
    'Name' => 'string',
    'Path' => 'string',
    'Icon' => 'binary',
    'LoadGroups' => 'int',
    'LoadUsers' => 'int',
    'LoadTopics' => 'int',
    'LoadColors' => 'int',
    'Options' => 'int',
    'SearchFor' => 'string',
    'SearchFields' => 'int',
    'States' => 'int',
    'Kinds' => 'int',
    'Priorities' => 'int',
    'PositiveFlags' => 'int',
    'NegativeFlags' => 'int',
    'MinClassified' => 'int',
    'MaxClassified' => 'int',
    'StartDate' => 'GhRpcFilterslibDatetime',
    'StartOperator' => 'int',
    'StartField' => 'int',
    'EndDate' => 'GhRpcFilterslibDatetime',
    'EndOperator' => 'int',
    'EndField' => 'int',
    'MinAge' => 'double',
    'MaxAge' => 'double',
    'MinSize' => 'int',
    'MaxSize' => 'int',
    'MinRemind' => 'double',
    'MaxRemind' => 'double',
    'UserFields' => 'array:GhRpcFilterslibRpcUserFieldItem',
    'LockData' => 'GhRpcFilterslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_filterslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcFilterslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_filterslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcFilterslibRpcUserFieldItem extends GhRpcStruct
{
  /**
   * FieldRef
   * @var int
   */
  public $FieldRef;

  /**
   * Compare
   * @var int
   */
  public $Compare;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Combine
   * @var int
   */
  public $Combine;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'FieldRef' => 'int',
    'Compare' => 'int',
    'Value' => 'string',
    'Combine' => 'int',
    'Order' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcFilters
 *
 * @package GhRpc
 * @subpackage rpc_filterslib
 * @category PHP-RPC-Dienste
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcFilterslibRpcFilters extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcFilterslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'ExecuteRuleForTempFilter' => array(
      'params' => array(
        'Filter' => 'GhRpcFilterslibRpcFilter',
        'RuleID' => 'int',
      ),
      'return' => '',
    ),
    'ExecuteRule' => array(
      'params' => array(
        'ID' => 'int',
        'RuleID' => 'int',
      ),
      'return' => '',
    ),
    'SetOrder' => array(
      'params' => array(
        'ID' => 'int',
        'Order' => 'int',
      ),
      'return' => '',
    ),
    'AddCategory' => array(
      'params' => array(
        'ID' => 'int',
        'CategoryRef' => 'int',
      ),
      'return' => '',
    ),
    'AddColor' => array(
      'params' => array(
        'ID' => 'int',
        'ColorRef' => 'int',
      ),
      'return' => '',
    ),
    'AddTopic' => array(
      'params' => array(
        'ID' => 'int',
        'TopicRef' => 'int',
      ),
      'return' => '',
    ),
    'AddUser' => array(
      'params' => array(
        'ID' => 'int',
        'UserRef' => 'int',
      ),
      'return' => '',
    ),
    'AddGroup' => array(
      'params' => array(
        'ID' => 'int',
        'GroupRef' => 'int',
      ),
      'return' => '',
    ),
    'SetViewOption' => array(
      'params' => array(
        'ID' => 'int',
        'ViewOptionRef' => 'int',
      ),
      'return' => '',
    ),
    'SetParent' => array(
      'params' => array(
        'ID' => 'int',
        'ParentRef' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Filter' => 'GhRpcFilterslibRpcFilter',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Filter' => 'GhRpcFilterslibRpcFilter',
      ),
      'return' => 'int',
    ),
    'GetCompleteList' => array(
      'params' => array(
        'AdvancedFields' => 'boolean',
      ),
      'return' => 'array:GhRpcFilterslibRpcFilter',
    ),
    'GetList' => array(
      'params' => array(
        'AdvancedFields' => 'boolean',
      ),
      'return' => 'array:GhRpcFilterslibRpcFilter',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcFilterslibRpcFilter',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcFilters.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcFilterslibRpcFilter
   */
  public function Get($ID)
  {
    return $this->_sendRpcRequest('RpcFilters.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param boolean $AdvancedFields
   *
   * @return array
   */
  public function GetList($AdvancedFields)
  {
    return $this->_sendRpcRequest('RpcFilters.GetList', array($AdvancedFields), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.GetCompleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param boolean $AdvancedFields
   *
   * @return array
   */
  public function GetCompleteList($AdvancedFields)
  {
    return $this->_sendRpcRequest('RpcFilters.GetCompleteList', array($AdvancedFields), self::$_rpcMethods['GetCompleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcFilterslibRpcFilter $Filter
   *
   * @return int
   */
  public function New_(GhRpcFilterslibRpcFilter $Filter)
  {
    return $this->_sendRpcRequest('RpcFilters.New', array($Filter), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcFilterslibRpcFilter $Filter
   */
  public function Put(GhRpcFilterslibRpcFilter $Filter)
  {
    return $this->_sendRpcRequest('RpcFilters.Put', array($Filter), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID)
  {
    return $this->_sendRpcRequest('RpcFilters.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.SetParent auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ParentRef
   */
  public function SetParent($ID, $ParentRef)
  {
    return $this->_sendRpcRequest('RpcFilters.SetParent', array($ID, $ParentRef), self::$_rpcMethods['SetParent']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.SetViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ViewOptionRef
   */
  public function SetViewOption($ID, $ViewOptionRef)
  {
    return $this->_sendRpcRequest('RpcFilters.SetViewOption', array($ID, $ViewOptionRef), self::$_rpcMethods['SetViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.AddGroup auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $GroupRef
   */
  public function AddGroup($ID, $GroupRef)
  {
    return $this->_sendRpcRequest('RpcFilters.AddGroup', array($ID, $GroupRef), self::$_rpcMethods['AddGroup']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.AddUser auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $UserRef
   */
  public function AddUser($ID, $UserRef)
  {
    return $this->_sendRpcRequest('RpcFilters.AddUser', array($ID, $UserRef), self::$_rpcMethods['AddUser']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.AddTopic auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TopicRef
   */
  public function AddTopic($ID, $TopicRef)
  {
    return $this->_sendRpcRequest('RpcFilters.AddTopic', array($ID, $TopicRef), self::$_rpcMethods['AddTopic']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.AddColor auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ColorRef
   */
  public function AddColor($ID, $ColorRef)
  {
    return $this->_sendRpcRequest('RpcFilters.AddColor', array($ID, $ColorRef), self::$_rpcMethods['AddColor']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.AddCategory auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $CategoryRef
   */
  public function AddCategory($ID, $CategoryRef)
  {
    return $this->_sendRpcRequest('RpcFilters.AddCategory', array($ID, $CategoryRef), self::$_rpcMethods['AddCategory']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.SetOrder auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Order
   */
  public function SetOrder($ID, $Order)
  {
    return $this->_sendRpcRequest('RpcFilters.SetOrder', array($ID, $Order), self::$_rpcMethods['SetOrder']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.ExecuteRule auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $RuleID
   */
  public function ExecuteRule($ID, $RuleID)
  {
    return $this->_sendRpcRequest('RpcFilters.ExecuteRule', array($ID, $RuleID), self::$_rpcMethods['ExecuteRule']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.ExecuteRuleForTempFilter auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcFilterslibRpcFilter $Filter
   * @param int $RuleID
   */
  public function ExecuteRuleForTempFilter(GhRpcFilterslibRpcFilter $Filter, $RuleID)
  {
    return $this->_sendRpcRequest('RpcFilters.ExecuteRuleForTempFilter', array($Filter, $RuleID), self::$_rpcMethods['ExecuteRuleForTempFilter']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID)
  {
    return $this->_sendRpcRequest('RpcFilters.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID)
  {
    return $this->_sendRpcRequest('RpcFilters.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcFilters.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcFilterslibRpcLockData
   */
  public function GetLockData($ID)
  {
    return $this->_sendRpcRequest('RpcFilters.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
