<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2017 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_pop3accountslib.
 *
 * @package GhRpc
 * @subpackage rpc_pop3accountslib
 * @category PHP-RPC-Units
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_pop3accountslib extends GhRpcLibrary
{
  // RpcPop3SslKind Konstanten:

  /**
   * pskAuto Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskAuto = 0;
  /**
   * pskSslv2 Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskSslv2 = 1;
  /**
   * pskSslv3 Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskSslv3 = 2;
  /**
   * pskTlsv1 Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskTlsv1 = 3;
  /**
   * pskTlsv11 Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskTlsv11 = 4;
  /**
   * pskTlsv12 Konstante (gehört zum Enum: RpcPop3SslKind).
   */
  const pskTlsv12 = 5;

  // RpcPop3ConvertPdfBW Konstanten:

  /**
   * cpbwYes Konstante (gehört zum Enum: RpcPop3ConvertPdfBW).
   */
  const cpbwYes = 0;
  /**
   * cpbwNo Konstante (gehört zum Enum: RpcPop3ConvertPdfBW).
   */
  const cpbwNo = 1;

  // RpcPop3Ocr Konstanten:

  /**
   * poAuto Konstante (gehört zum Enum: RpcPop3Ocr).
   */
  const poAuto = 0;
  /**
   * poSections Konstante (gehört zum Enum: RpcPop3Ocr).
   */
  const poSections = 1;
  /**
   * poDisabled Konstante (gehört zum Enum: RpcPop3Ocr).
   */
  const poDisabled = 2;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  // RpcPop3Encrypt Konstanten:

  /**
   * peNo Konstante (gehört zum Enum: RpcPop3Encrypt).
   */
  const peNo = 0;
  /**
   * peSSL Konstante (gehört zum Enum: RpcPop3Encrypt).
   */
  const peSSL = 1;
  /**
   * peSTARTTLS Konstante (gehört zum Enum: RpcPop3Encrypt).
   */
  const peSTARTTLS = 2;

  // RpcPop3Flag Konstanten:

  /**
   * pfAssignSubject Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfAssignSubject = 0;
  /**
   * pfAssignContent Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfAssignContent = 1;
  /**
   * pfExtractIdentifier Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfExtractIdentifier = 2;
  /**
   * pfOverwriteFrom Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfOverwriteFrom = 3;
  /**
   * pfOverwriteTo Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfOverwriteTo = 4;
  /**
   * pfUseAPop Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfUseAPop = 5;
  /**
   * pfSplitLetter Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfSplitLetter = 6;
  /**
   * pfNoSpam Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfNoSpam = 7;
  /**
   * pfNoVirus Konstante (gehört zum Enum: RpcPop3Flag).
   */
  const pfNoVirus = 8;

  // RpcPop3Kind Konstanten:

  /**
   * pkEmail Konstante (gehört zum Enum: RpcPop3Kind).
   */
  const pkEmail = 0;
  /**
   * pkFax Konstante (gehört zum Enum: RpcPop3Kind).
   */
  const pkFax = 1;
  /**
   * pkLetter Konstante (gehört zum Enum: RpcPop3Kind).
   */
  const pkLetter = 2;
  /**
   * pkShortMessage Konstante (gehört zum Enum: RpcPop3Kind).
   */
  const pkShortMessage = 3;

  // RpcPop3Delete Konstanten:

  /**
   * pdYes Konstante (gehört zum Enum: RpcPop3Delete).
   */
  const pdYes = 0;
  /**
   * pdNo Konstante (gehört zum Enum: RpcPop3Delete).
   */
  const pdNo = 1;
  /**
   * pdDelayed Konstante (gehört zum Enum: RpcPop3Delete).
   */
  const pdDelayed = 2;

  // RpcPop3State Konstanten:

  /**
   * psInactive Konstante (gehört zum Enum: RpcPop3State).
   */
  const psInactive = 0;
  /**
   * psActive Konstante (gehört zum Enum: RpcPop3State).
   */
  const psActive = 1;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcPop3Accounts.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcPop3accountslibRpcPop3Accounts
   */
  public static function newRpcPop3Accounts(GhRpcClient $client)
  {
    return new GhRpcPop3accountslibRpcPop3Accounts($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcPop3accountslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcPop3accountslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcPop3AccountItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcPop3accountslibRpcPop3AccountItem
   */
  public static function newRpcPop3AccountItem($fillProperties = false)
  {
    $object = new GhRpcPop3accountslibRpcPop3AccountItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcPop3Account.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcPop3accountslibRpcPop3Account
   */
  public static function newRpcPop3Account($fillProperties = false)
  {
    $object = new GhRpcPop3accountslibRpcPop3Account();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcPop3AccountList.
 *
 * @package GhRpc
 * @subpackage rpc_pop3accountslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcPop3accountslibRpcPop3Account extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Host
   * @var string
   */
  public $Host;

  /**
   * Port
   * @var int
   */
  public $Port;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * MaxSize
   * @var int
   */
  public $MaxSize;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * Delete
   * @var int
   */
  public $Delete;

  /**
   * DeleteAge
   * @var int
   */
  public $DeleteAge;

  /**
   * DeleteSync
   * @var boolean
   */
  public $DeleteSync;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Encrypt
   * @var int
   */
  public $Encrypt;

  /**
   * SslKind
   * @var int
   */
  public $SslKind;

  /**
   * Interval
   * @var int
   */
  public $Interval;

  /**
   * FromOverwrite
   * @var string
   */
  public $FromOverwrite;

  /**
   * ToOverwrite
   * @var string
   */
  public $ToOverwrite;

  /**
   * Ocr
   * @var int
   */
  public $Ocr;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * OcrData
   * @var string
   */
  public $OcrData;

  /**
   * PageAngle
   * @var int
   */
  public $PageAngle;

  /**
   * PageTreshold
   * @var double
   */
  public $PageTreshold;

  /**
   * ConvertPdfBW
   * @var int
   */
  public $ConvertPdfBW;

  /**
   * ErrorCount
   * @var int
   */
  public $ErrorCount;

  /**
   * Message
   * @var string
   */
  public $Message;

  /**
   * LockData
   * @var GhRpcPop3accountslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Name' => 'string',
    'State' => 'int',
    'Host' => 'string',
    'Port' => 'int',
    'Timeout' => 'int',
    'MaxSize' => 'int',
    'Username' => 'string',
    'Password' => 'string',
    'Delete' => 'int',
    'DeleteAge' => 'int',
    'DeleteSync' => 'boolean',
    'Kind' => 'int',
    'Flags' => 'int',
    'Encrypt' => 'int',
    'SslKind' => 'int',
    'Interval' => 'int',
    'FromOverwrite' => 'string',
    'ToOverwrite' => 'string',
    'Ocr' => 'int',
    'EditorData' => 'binary',
    'OcrData' => 'binary',
    'PageAngle' => 'int',
    'PageTreshold' => 'double',
    'ConvertPdfBW' => 'int',
    'ErrorCount' => 'int',
    'Message' => 'string',
    'LockData' => 'GhRpcPop3accountslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcPop3AccountList.
 *
 * @package GhRpc
 * @subpackage rpc_pop3accountslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcPop3accountslibRpcPop3AccountItem extends GhRpcStruct
{
  /**
   * Host
   * @var string
   */
  public $Host;

  /**
   * Port
   * @var int
   */
  public $Port;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * UseAPop
   * @var boolean
   */
  public $UseAPop;

  /**
   * Encrypt
   * @var int
   */
  public $Encrypt;

  /**
   * SslKind
   * @var int
   */
  public $SslKind;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Host' => 'string',
    'Port' => 'int',
    'Username' => 'string',
    'Password' => 'string',
    'Timeout' => 'int',
    'UseAPop' => 'boolean',
    'Encrypt' => 'int',
    'SslKind' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcPop3AccountList.
 *
 * @package GhRpc
 * @subpackage rpc_pop3accountslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcPop3accountslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcPop3Accounts
 *
 * @package GhRpc
 * @subpackage rpc_pop3accountslib
 * @category PHP-RPC-Dienste
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcPop3accountslibRpcPop3Accounts extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcPop3accountslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'ResetUIDL' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'CheckConnection' => array(
      'params' => array(
        'Pop3AccountItem' => 'GhRpcPop3accountslibRpcPop3AccountItem',
      ),
      'return' => 'int',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Pop3Account' => 'GhRpcPop3accountslibRpcPop3Account',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Pop3Account' => 'GhRpcPop3accountslibRpcPop3Account',
      ),
      'return' => 'int',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcPop3accountslibRpcPop3Account',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcPop3accountslibRpcPop3Account',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcPop3accountslibRpcPop3Account
   */
  public function Get($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcPop3accountslibRpcPop3Account $Pop3Account
   *
   * @return int
   */
  public function New_(GhRpcPop3accountslibRpcPop3Account $Pop3Account)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.New', array($Pop3Account), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcPop3accountslibRpcPop3Account $Pop3Account
   */
  public function Put(GhRpcPop3accountslibRpcPop3Account $Pop3Account)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.Put', array($Pop3Account), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.CheckConnection auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcPop3accountslibRpcPop3AccountItem $Pop3AccountItem
   *
   * @return int
   */
  public function CheckConnection(GhRpcPop3accountslibRpcPop3AccountItem $Pop3AccountItem)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.CheckConnection', array($Pop3AccountItem), self::$_rpcMethods['CheckConnection']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.ResetUIDL auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function ResetUIDL($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.ResetUIDL', array($ID), self::$_rpcMethods['ResetUIDL']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcPop3Accounts.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcPop3accountslibRpcLockData
   */
  public function GetLockData($ID)
  {
    return $this->_sendRpcRequest('RpcPop3Accounts.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
