<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2017 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_ruleslib.
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Units
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_ruleslib extends GhRpcLibrary
{
  // RpcTriggerOption Konstanten:

  /**
   * toAll Konstante (gehört zum Enum: RpcTriggerOption).
   */
  const toAll = 0;
  /**
   * toManual Konstante (gehört zum Enum: RpcTriggerOption).
   */
  const toManual = 1;
  /**
   * toItemWorkflow Konstante (gehört zum Enum: RpcTriggerOption).
   */
  const toItemWorkflow = 2;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  // RpcRecurrenceType Konstanten:

  /**
   * rtDaily Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtDaily = 0;
  /**
   * rtWeekly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtWeekly = 1;
  /**
   * rtMonthly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtMonthly = 2;
  /**
   * rtYearly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtYearly = 3;

  // RpcOccurDay Konstanten:

  /**
   * odMonday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odMonday = 0;
  /**
   * odTuesday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odTuesday = 1;
  /**
   * odWednesday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odWednesday = 2;
  /**
   * odThursday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odThursday = 3;
  /**
   * odFriday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odFriday = 4;
  /**
   * odSaturday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odSaturday = 5;
  /**
   * odSunday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odSunday = 6;

  // RpcDayType Konstanten:

  /**
   * dtDay Konstante (gehört zum Enum: RpcDayType).
   */
  const dtDay = 0;
  /**
   * dtEveryday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtEveryday = 1;
  /**
   * dtWeekday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWeekday = 2;
  /**
   * dtWeekendday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWeekendday = 3;
  /**
   * dtSunday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtSunday = 4;
  /**
   * dtMonday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtMonday = 5;
  /**
   * dtTuesday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtTuesday = 6;
  /**
   * dtWednesday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWednesday = 7;
  /**
   * dtThursday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtThursday = 8;
  /**
   * dtFriday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtFriday = 9;
  /**
   * dtSaturday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtSaturday = 10;

  // RpcRuleTrigger Konstanten:

  /**
   * rtAfterIncoming Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtAfterIncoming = 0;
  /**
   * rtAfterOutgoing Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtAfterOutgoing = 1;
  /**
   * rtManual Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtManual = 2;
  /**
   * rtNew Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtNew = 3;
  /**
   * rtEdit Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtEdit = 4;
  /**
   * rtTime Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtTime = 5;
  /**
   * rtItemWorkflow Konstante (gehört zum Enum: RpcRuleTrigger).
   */
  const rtItemWorkflow = 6;

  // RpcRuleKind Konstanten:

  /**
   * rkExpert Konstante (gehört zum Enum: RpcRuleKind).
   */
  const rkExpert = 0;
  /**
   * rkScript Konstante (gehört zum Enum: RpcRuleKind).
   */
  const rkScript = 1;

  // RpcRuleState Konstanten:

  /**
   * rsInactive Konstante (gehört zum Enum: RpcRuleState).
   */
  const rsInactive = 0;
  /**
   * rsActive Konstante (gehört zum Enum: RpcRuleState).
   */
  const rsActive = 1;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcRules.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcRuleslibRpcRules
   */
  public static function newRpcRules(GhRpcClient $client)
  {
    return new GhRpcRuleslibRpcRules($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcRuleslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcRuleslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRuleItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcRuleslibRpcRuleItem
   */
  public static function newRpcRuleItem($fillProperties = false)
  {
    $object = new GhRpcRuleslibRpcRuleItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRule.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcRuleslibRpcRule
   */
  public static function newRpcRule($fillProperties = false)
  {
    $object = new GhRpcRuleslibRpcRule();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRuleRecurrence.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcRuleslibRpcRuleRecurrence
   */
  public static function newRpcRuleRecurrence($fillProperties = false)
  {
    $object = new GhRpcRuleslibRpcRuleRecurrence();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcRuleList.
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcRuleslibRpcRuleRecurrence extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Count
   * @var int
   */
  public $Count;

  /**
   * DayNumber
   * @var int
   */
  public $DayNumber;

  /**
   * DayType
   * @var int
   */
  public $DayType;

  /**
   * OccurDays
   * @var int
   */
  public $OccurDays;

  /**
   * Recurrence
   * @var int
   */
  public $Recurrence;

  /**
   * Periodicity
   * @var int
   */
  public $Periodicity;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * NextOccurrence
   * @var GhRpcDateTime
   */
  public $NextOccurrence;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Count' => 'int',
    'DayNumber' => 'int',
    'DayType' => 'int',
    'OccurDays' => 'int',
    'Recurrence' => 'int',
    'Periodicity' => 'int',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'NextOccurrence' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcRuleList.
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcRuleslibRpcRule extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * CategoryRefs
   * @var array
   */
  public $CategoryRefs;

  /**
   * FilterRefs
   * @var array
   */
  public $FilterRefs;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Triggers
   * @var int
   */
  public $Triggers;

  /**
   * Recurrence
   * @var GhRpcRuleslibRpcRuleRecurrence
   */
  public $Recurrence;

  /**
   * ExpertData
   * @var string
   */
  public $ExpertData;

  /**
   * SourceCode
   * @var string
   */
  public $SourceCode;

  /**
   * Compiled
   * @var boolean
   */
  public $Compiled;

  /**
   * Message
   * @var string
   */
  public $Message;

  /**
   * LockData
   * @var GhRpcRuleslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'CategoryRefs' => 'array:int',
    'FilterRefs' => 'array:int',
    'Order' => 'int',
    'State' => 'int',
    'Name' => 'string',
    'Kind' => 'int',
    'Triggers' => 'int',
    'Recurrence' => 'GhRpcRuleslibRpcRuleRecurrence',
    'ExpertData' => 'string',
    'SourceCode' => 'string',
    'Compiled' => 'boolean',
    'Message' => 'string',
    'LockData' => 'GhRpcRuleslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcRuleList.
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcRuleslibRpcRuleItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Triggers
   * @var int
   */
  public $Triggers;

  /**
   * Compiled
   * @var boolean
   */
  public $Compiled;

  /**
   * Message
   * @var string
   */
  public $Message;

  /**
   * LockData
   * @var GhRpcRuleslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Order' => 'int',
    'State' => 'int',
    'Name' => 'string',
    'Kind' => 'int',
    'Triggers' => 'int',
    'Compiled' => 'boolean',
    'Message' => 'string',
    'LockData' => 'GhRpcRuleslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcRuleList.
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Datenklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcRuleslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcRules
 *
 * @package GhRpc
 * @subpackage rpc_ruleslib
 * @category PHP-RPC-Dienste
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2017 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcRuleslibRpcRules extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcRuleslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Export' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'string',
    ),
    'Import' => array(
      'params' => array(
        'XmlData' => 'string',
      ),
      'return' => 'int',
    ),
    'DeleteGlobal' => array(
      'params' => array(
        'Name' => 'string',
      ),
      'return' => '',
    ),
    'PutGlobals' => array(
      'params' => array(
        'Globals' => 'string',
      ),
      'return' => '',
    ),
    'PutGlobal' => array(
      'params' => array(
        'Name' => 'string',
        'Value' => 'string',
      ),
      'return' => '',
    ),
    'GetGlobals' => array(
      'params' => array(
      ),
      'return' => 'string',
    ),
    'GetGlobal' => array(
      'params' => array(
        'Name' => 'string',
      ),
      'return' => 'string',
    ),
    'CheckSourceCode' => array(
      'params' => array(
        'SourceCode' => 'string',
      ),
      'return' => 'string',
    ),
    'GetSourceCode' => array(
      'params' => array(
        'ExpertData' => 'string',
      ),
      'return' => 'string',
    ),
    'SetOrder' => array(
      'params' => array(
        'ID' => 'int',
        'Order' => 'int',
      ),
      'return' => '',
    ),
    'AddFilter' => array(
      'params' => array(
        'ID' => 'int',
        'FilterRef' => 'int',
      ),
      'return' => '',
    ),
    'AddCategory' => array(
      'params' => array(
        'ID' => 'int',
        'CategoryRef' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Rule' => 'GhRpcRuleslibRpcRule',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Rule' => 'GhRpcRuleslibRpcRule',
      ),
      'return' => 'int',
    ),
    'GetList' => array(
      'params' => array(
        'TriggerOption' => 'int',
      ),
      'return' => 'array:GhRpcRuleslibRpcRuleItem',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcRuleslibRpcRule',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcRules.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcRuleslibRpcRule
   */
  public function Get($ID)
  {
    return $this->_sendRpcRequest('RpcRules.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $TriggerOption
   *
   * @return array
   */
  public function GetList($TriggerOption)
  {
    return $this->_sendRpcRequest('RpcRules.GetList', array($TriggerOption), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcRuleslibRpcRule $Rule
   *
   * @return int
   */
  public function New_(GhRpcRuleslibRpcRule $Rule)
  {
    return $this->_sendRpcRequest('RpcRules.New', array($Rule), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcRuleslibRpcRule $Rule
   */
  public function Put(GhRpcRuleslibRpcRule $Rule)
  {
    return $this->_sendRpcRequest('RpcRules.Put', array($Rule), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID)
  {
    return $this->_sendRpcRequest('RpcRules.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.AddCategory auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $CategoryRef
   */
  public function AddCategory($ID, $CategoryRef)
  {
    return $this->_sendRpcRequest('RpcRules.AddCategory', array($ID, $CategoryRef), self::$_rpcMethods['AddCategory']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.AddFilter auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $FilterRef
   */
  public function AddFilter($ID, $FilterRef)
  {
    return $this->_sendRpcRequest('RpcRules.AddFilter', array($ID, $FilterRef), self::$_rpcMethods['AddFilter']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.SetOrder auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Order
   */
  public function SetOrder($ID, $Order)
  {
    return $this->_sendRpcRequest('RpcRules.SetOrder', array($ID, $Order), self::$_rpcMethods['SetOrder']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.GetSourceCode auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $ExpertData
   *
   * @return string
   */
  public function GetSourceCode($ExpertData)
  {
    return $this->_sendRpcRequest('RpcRules.GetSourceCode', array($ExpertData), self::$_rpcMethods['GetSourceCode']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.CheckSourceCode auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $SourceCode
   *
   * @return string
   */
  public function CheckSourceCode($SourceCode)
  {
    return $this->_sendRpcRequest('RpcRules.CheckSourceCode', array($SourceCode), self::$_rpcMethods['CheckSourceCode']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.GetGlobal auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Name
   *
   * @return string
   */
  public function GetGlobal($Name)
  {
    return $this->_sendRpcRequest('RpcRules.GetGlobal', array($Name), self::$_rpcMethods['GetGlobal']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.GetGlobals auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return string
   */
  public function GetGlobals()
  {
    return $this->_sendRpcRequest('RpcRules.GetGlobals', array(), self::$_rpcMethods['GetGlobals']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.PutGlobal auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Name
   * @param string $Value
   */
  public function PutGlobal($Name, $Value)
  {
    return $this->_sendRpcRequest('RpcRules.PutGlobal', array($Name, $Value), self::$_rpcMethods['PutGlobal']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.PutGlobals auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Globals
   */
  public function PutGlobals($Globals)
  {
    return $this->_sendRpcRequest('RpcRules.PutGlobals', array($Globals), self::$_rpcMethods['PutGlobals']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.DeleteGlobal auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Name
   */
  public function DeleteGlobal($Name)
  {
    return $this->_sendRpcRequest('RpcRules.DeleteGlobal', array($Name), self::$_rpcMethods['DeleteGlobal']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Import auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $XmlData
   *
   * @return int
   */
  public function Import($XmlData)
  {
    return $this->_sendRpcRequest('RpcRules.Import', array($XmlData), self::$_rpcMethods['Import']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Export auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return string
   */
  public function Export($ID)
  {
    return $this->_sendRpcRequest('RpcRules.Export', array($ID), self::$_rpcMethods['Export']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID)
  {
    return $this->_sendRpcRequest('RpcRules.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID)
  {
    return $this->_sendRpcRequest('RpcRules.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcRules.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcRuleslibRpcLockData
   */
  public function GetLockData($ID)
  {
    return $this->_sendRpcRequest('RpcRules.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
